Index: tools/mkfat.py
===================================================================
--- tools/mkfat.py	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ tools/mkfat.py	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -343,12 +343,18 @@
 def usage(prname):
 	"Print usage syntax"
-	print prname + " <PATH> <IMAGE>"
+	print prname + " <EXTRA_BYTES> <PATH> <IMAGE>"
 
 def main():
-	if (len(sys.argv) < 3):
+	if (len(sys.argv) < 4):
 		usage(sys.argv[0])
 		return
 	
-	path = os.path.abspath(sys.argv[1])
+	if (not sys.argv[1].isdigit()):
+		print "<EXTRA_BYTES> must be a number"
+		return
+	
+	extra_bytes = int(sys.argv[1])
+	
+	path = os.path.abspath(sys.argv[2])
 	if (not os.path.isdir(path)):
 		print "<PATH> must be a directory"
@@ -365,9 +371,9 @@
 	
 	# Make sure the filesystem is large enought for FAT16
-	size = subtree_size(path, cluster_size, dirent_size) + reserved_clusters * cluster_size
+	size = subtree_size(path, cluster_size, dirent_size) + reserved_clusters * cluster_size + extra_bytes
 	while (size / cluster_size < fat16_clusters):
 		if (cluster_size > sector_size):
 			cluster_size /= 2
-			size = subtree_size(path, cluster_size, dirent_size) + reserved_clusters * cluster_size
+			size = subtree_size(path, cluster_size, dirent_size) + reserved_clusters * cluster_size + extra_bytes
 		else:
 			size = fat16_clusters * cluster_size + reserved_clusters * cluster_size
@@ -381,5 +387,5 @@
 	data_start = root_start + root_size
 	
-	outf = file(sys.argv[2], "w")
+	outf = file(sys.argv[3], "w")
 	
 	boot_sector = xstruct.create(BOOT_SECTOR)
Index: tools/mkuimage.py
===================================================================
--- tools/mkuimage.py	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ tools/mkuimage.py	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,160 @@
+#!/usr/bin/env python
+#
+# Copyright (c) 2010 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+"""
+Create legacy uImage (U-Boot image)
+"""
+
+from collections import deque
+import os
+import sys
+import xstruct
+import zlib
+
+UIMAGE_HEADER = """big:
+	uint32_t magic
+	uint32_t header_crc
+	uint32_t c_tstamp
+	uint32_t data_size
+	uint32_t load_addr
+	uint32_t start_addr
+	uint32_t data_crc
+	uint8_t os
+	uint8_t arch
+	uint8_t img_type
+	uint8_t compression
+	char img_name[32]
+"""
+
+def main():
+	args = deque(sys.argv)
+	cmd_name = args.popleft()
+	base_name = os.path.basename(cmd_name)
+	image_name = 'Noname'
+	load_addr = 0
+	start_addr = 0
+
+	while len(args) >= 2 and args[0][0] == '-':
+		opt = args.popleft()[1:]
+		optarg = args.popleft()
+
+		if opt == 'name':
+			image_name = optarg
+		elif opt == 'laddr':
+			load_addr = (int)(optarg, 0)
+		elif opt == 'saddr':
+			start_addr = (int)(optarg, 0)
+		else:
+			print base_name + ": Unrecognized option."
+			print_syntax(cmd_name)
+			return
+
+	if len(args) < 2:
+		print base_name + ": Argument missing."
+		print_syntax(cmd_name)
+		return
+
+	inf_name = args[0]
+	outf_name = args[1]
+
+	try:
+		mkuimage(inf_name, outf_name, image_name, load_addr, start_addr)
+	except:
+		os.remove(outf_name)
+		raise
+
+def mkuimage(inf_name, outf_name, image_name, load_addr, start_addr):
+	inf = file(inf_name, 'rb')
+	outf = file(outf_name, 'wb')
+
+	header = xstruct.create(UIMAGE_HEADER)
+	header_size = header.size()
+
+	#
+	# Write data
+	#
+	outf.seek(header_size, os.SEEK_SET)
+	data = inf.read()
+	data_size = inf.tell()
+	data_crc = calc_crc32(data)
+	data_tstamp = (int)(os.path.getmtime(inf_name))
+	outf.write(data)
+	data = ''
+
+	#
+	# Write header
+	#
+	outf.seek(0, os.SEEK_SET)
+
+	header.magic = 0x27051956	# uImage magic
+	header.header_crc = 0
+	header.c_tstamp = data_tstamp
+	header.data_size = data_size
+	header.load_addr = load_addr	# Address where to load image
+	header.start_addr = start_addr	# Address of entry point
+	header.data_crc = data_crc
+	header.os = 5			# Linux
+	header.arch = 2			# ARM
+	header.img_type = 2		# Kernel
+	header.compression = 0		# None
+	header.img_name = image_name
+
+	header_crc = calc_crc32(header.pack())
+	header.header_crc = header_crc
+
+	outf.write(header.pack())
+	outf.close()
+
+## Compute CRC32 of binary string.
+#
+# Works around bug in zlib.crc32() which returns signed int32 result
+# in Python < 3.0.
+#
+def calc_crc32(byteseq):
+	signed_crc = zlib.crc32(byteseq, 0)
+	if signed_crc < 0:
+		return (long(signed_crc) + 4294967296L) # 2^32L
+	else:
+		return signed_crc
+
+## Print command-line syntax.
+#
+def print_syntax(cmd):
+	print "syntax: " + cmd + " [<options>] <raw_image> <uImage>"
+	print
+	print "\traw_image\tInput image name (raw binary data)"
+	print "\tuImage\t\tOutput uImage name (U-Boot image)"
+	print
+	print "options:"
+	print "\t-name <name>\tImage name (default: 'Noname')"
+	print "\t-laddr <name>\tLoad address (default: 0x00000000)"
+	print "\t-saddr <name>\tStart address (default: 0x00000000)"
+
+if __name__ == '__main__':
+	main()
Index: tools/pack.py
===================================================================
--- tools/pack.py	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ tools/pack.py	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -191,5 +191,5 @@
 	link_in.close()
 	
-	link_out = file(os.path.join(arch_path, LINK), "w")
+	link_out = file(os.path.join(arch_path, "%s.comp" % LINK), "w")
 	link_out.write(template.replace("[[COMPONENTS]]", "\n".join(link_ctx)))
 	link_out.close()
Index: tools/toolchain.sh
===================================================================
--- tools/toolchain.sh	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ tools/toolchain.sh	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -1,3 +1,3 @@
-#!/bin/bash
+#! /bin/bash
 
 #
@@ -33,4 +33,5 @@
 		echo
 		echo "Script failed: $2"
+		
 		exit 1
 	fi
@@ -45,4 +46,5 @@
 		echo
 		echo "Checksum of ${FILE} does not match."
+		
 		exit 2
 	fi
@@ -71,4 +73,52 @@
 }
 
+change_title() {
+	echo -en "\e]0;$1\a"
+}
+
+show_countdown() {
+	TM="$1"
+	
+	if [ "${TM}" -eq 0 ] ; then
+		echo
+		return 0
+	fi
+	
+	echo -n "${TM} "
+	change_title "${TM}"
+	sleep 1
+	
+	TM="`expr "${TM}" - 1`"
+	show_countdown "${TM}"
+}
+
+show_dependencies() {
+	echo "IMPORTANT NOTICE:"
+	echo
+	echo "For a successful compilation and use of the cross-compiler"
+	echo "toolchain you need at least the following dependencies."
+	echo
+	echo "Please make sure that the dependencies are present in your"
+	echo "system. Otherwise the compilation process might fail after"
+	echo "a few seconds or minutes."
+	echo
+	echo " - SED, AWK, Flex, Bison, gzip, bzip2, Bourne Shell"
+	echo " - gettext, zlib, Texinfo, libelf, libgomp"
+	echo " - GNU Multiple Precision Library (GMP)"
+	echo " - GNU Make"
+	echo " - GNU tar"
+	echo " - GNU Coreutils"
+	echo " - GNU Sharutils"
+	echo " - MPFR"
+	echo " - MPC"
+	echo " - Parma Polyhedra Library (PPL)"
+	echo " - ClooG-PPL"
+	echo " - native C compiler, assembler and linker"
+	echo " - native C library with headers"
+	echo
+	
+	show_countdown 10
+}
+
 download_check() {
 	SOURCE="$1"
@@ -77,4 +127,5 @@
 	
 	if [ ! -f "${FILE}" ]; then
+		change_title "Downloading ${FILE}"
 		wget -c "${SOURCE}${FILE}"
 		check_error $? "Error downloading ${FILE}."
@@ -88,4 +139,5 @@
 	
 	if [ -d "${DIR}" ]; then
+		change_title "Removing ${DIR}"
 		echo " >>> Removing ${DIR}"
 		rm -fr "${DIR}"
@@ -97,4 +149,5 @@
 	DESC="$2"
 	
+	change_title "Creating ${DESC}"
 	echo ">>> Creating ${DESC}"
 	
@@ -108,5 +161,6 @@
 	DESC="$2"
 	
-	echo " >>> ${DESC}"
+	change_title "Unpacking ${DESC}"
+	echo " >>> Unpacking ${DESC}"
 	
 	tar -xjf "${FILE}"
@@ -142,5 +196,5 @@
 	
 	BINUTILS_VERSION="2.20"
-	GCC_VERSION="4.5.0"
+	GCC_VERSION="4.5.1"
 	
 	BINUTILS="binutils-${BINUTILS_VERSION}.tar.bz2"
@@ -165,7 +219,7 @@
 	echo ">>> Downloading tarballs"
 	download_check "${BINUTILS_SOURCE}" "${BINUTILS}" "ee2d3e996e9a2d669808713360fa96f8"
-	download_check "${GCC_SOURCE}" "${GCC_CORE}" "58eda33c3184303628f91c42a7ab15b5"
-	download_check "${GCC_SOURCE}" "${GCC_OBJC}" "8d8c01b6631b020cc6c167860fde2398"
-	download_check "${GCC_SOURCE}" "${GCC_CPP}" "5ab93605af40def4844eda09ca769c2d"
+	download_check "${GCC_SOURCE}" "${GCC_CORE}" "dc8959e31b01a65ce10d269614815054"
+	download_check "${GCC_SOURCE}" "${GCC_OBJC}" "3c11b7037896e967eddf8178af2ddd98"
+	download_check "${GCC_SOURCE}" "${GCC_CPP}" "b294953ff0bb2f20c7acb2bf005d832a"
 	
 	echo ">>> Removing previous content"
@@ -184,18 +238,26 @@
 	unpack_tarball "${GCC_CPP}" "C++"
 	
-	echo ">>> Compiling and installing binutils"
+	echo ">>> Processing binutils (${PLATFORM})"
 	cd "${BINUTILSDIR}"
 	check_error $? "Change directory failed."
 	patch_binutils "${PLATFORM}"
-	./configure "--target=${TARGET}" "--prefix=${PREFIX}" "--program-prefix=${TARGET}-" "--disable-nls"
+	
+	change_title "binutils: configure (${PLATFORM})"
+	./configure "--target=${TARGET}" "--prefix=${PREFIX}" "--program-prefix=${TARGET}-" --disable-nls
 	check_error $? "Error configuring binutils."
+	
+	change_title "binutils: make (${PLATFORM})"
 	make all install
 	check_error $? "Error compiling/installing binutils."
 	
-	echo ">>> Compiling and installing GCC"
+	echo ">>> Processing GCC (${PLATFORM})"
 	cd "${OBJDIR}"
 	check_error $? "Change directory failed."
+	
+	change_title "GCC: configure (${PLATFORM})"
 	"${GCCDIR}/configure" "--target=${TARGET}" "--prefix=${PREFIX}" "--program-prefix=${TARGET}-" --with-gnu-as --with-gnu-ld --disable-nls --disable-threads --enable-languages=c,objc,c++,obj-c++ --disable-multilib --disable-libgcj --without-headers --disable-shared --enable-lto
 	check_error $? "Error configuring GCC."
+	
+	change_title "GCC: make (${PLATFORM})"
 	PATH="${PATH}:${PREFIX}/bin" make all-gcc install-gcc
 	check_error $? "Error compiling/installing GCC."
@@ -216,4 +278,6 @@
 	show_usage
 fi
+
+show_dependencies
 
 case "$1" in
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/Makefile	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -70,7 +70,9 @@
 	srv/hid/adb_mouse \
 	srv/hid/char_mouse \
+	srv/hid/s3c24xx_ts \
 	srv/hid/fb \
 	srv/hid/kbd \
 	srv/hw/char/i8042 \
+	srv/hw/char/s3c24xx_uart \
 	srv/hw/netif/dp8390 \
 	srv/net/cfg \
@@ -141,5 +143,5 @@
 	lib/softfloat \
 	lib/drv \
-	lib/socket \
+	lib/packet \
 	lib/net
 
Index: uspace/Makefile.common
===================================================================
--- uspace/Makefile.common	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/Makefile.common	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -89,6 +89,5 @@
 
 LIBDRV_PREFIX = $(LIB_PREFIX)/drv
-
-LIBSOCKET_PREFIX = $(LIB_PREFIX)/socket
+LIBPACKET_PREFIX = $(LIB_PREFIX)/packet
 LIBNET_PREFIX = $(LIB_PREFIX)/net
 
@@ -96,4 +95,10 @@
 
 LINKER_SCRIPT ?= $(LIBC_PREFIX)/arch/$(UARCH)/_link.ld
+
+ifeq ($(CONFIG_OPTIMIZE_FOR_SIZE),y)
+	OPTIMIZATION = s
+else
+	OPTIMIZATION = 3
+endif
 
 .PHONY: all clean
@@ -105,10 +110,4 @@
 	rm -f $(DEPEND) $(DEPEND_PREV) $(JOB) $(OUTPUT) $(EXTRA_OUTPUT) $(EXTRA_CLEAN)
 	find . -name '*.o' -follow -exec rm \{\} \;
-
-ifeq ($(CONFIG_OPTIMIZE_FOR_SIZE),y)
-OPTIMIZATION = s
-else
-OPTIMIZATION = 3
-endif
 
 GCC_CFLAGS = -I$(LIBC_PREFIX)/include -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
@@ -117,5 +116,5 @@
 	-Wall -Wextra -Wno-clobbered -Wno-unused-parameter -Wmissing-prototypes \
 	-Werror-implicit-function-declaration -Wwrite-strings \
-	-Werror -pipe -g -D__$(ENDIANESS)__
+	-pipe -g -D__$(ENDIANESS)__
 
 ICC_CFLAGS = -I$(LIBC_PREFIX)/include -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
@@ -124,5 +123,5 @@
 	-Wall -Wextra -Wno-clobbered -Wno-unused-parameter -Wmissing-prototypes \
 	-Werror-implicit-function-declaration -Wwrite-strings \
-	-Werror -pipe -g -D__$(ENDIANESS)__
+	-pipe -g -D__$(ENDIANESS)__
 
 CLANG_CFLAGS = -I$(LIBC_PREFIX)/include -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
@@ -133,4 +132,9 @@
 	-pipe -g -arch $(CLANG_ARCH) -D__$(ENDIANESS)__
 
+ifeq ($(CONFIG_DEBUG),y)
+	GCC_CFLAGS += -Werror
+	ICC_CFLAGS += -Werror
+endif
+
 ## Setup platform configuration
 #
@@ -169,5 +173,9 @@
 ifneq ($(BINARY),)
 %.disasm: $(BINARY)
+ifeq ($(CONFIG_LINE_DEBUG),y)
+	$(OBJDUMP) -d -S $< > $@
+else
 	$(OBJDUMP) -d $< > $@
+endif
 
 $(BINARY): $(LINKER_SCRIPT) $(OBJECTS) $(LIBS) $(BASE_LIBS)
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/init/init.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -274,6 +274,8 @@
 	srv_start("/srv/cuda_adb");
 	srv_start("/srv/i8042");
+	srv_start("/srv/s3c24ser");
 	srv_start("/srv/adb_ms");
 	srv_start("/srv/char_ms");
+	srv_start("/srv/s3c24ts");
 	
 	spawn("/srv/fb");
Index: uspace/app/klog/klog.c
===================================================================
--- uspace/app/klog/klog.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/klog/klog.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -43,11 +43,15 @@
 #include <event.h>
 #include <errno.h>
+#include <str_error.h>
 #include <io/klog.h>
 
-#define NAME  "klog"
+#define NAME       "klog"
+#define LOG_FNAME  "/log/klog"
 
 /* Pointer to klog area */
 static wchar_t *klog;
 static size_t klog_length;
+
+static FILE *log;
 
 static void interrupt_received(ipc_callid_t callid, ipc_call_t *call)
@@ -58,6 +62,17 @@
 	size_t i;
 	
-	for (i = klog_len - klog_stored; i < klog_len; i++)
-		putchar(klog[(klog_start + i) % klog_length]);
+	for (i = klog_len - klog_stored; i < klog_len; i++) {
+		wchar_t ch = klog[(klog_start + i) % klog_length];
+		
+		putchar(ch);
+		
+		if (log != NULL)
+			fputc(ch, log);
+	}
+	
+	if (log != NULL) {
+		fflush(log);
+		fsync(fileno(log));
+	}
 }
 
@@ -91,4 +106,14 @@
 	}
 	
+	/*
+	 * Mode "a" would be definitively much better here, but it is
+	 * not well supported by the FAT driver.
+	 *
+	 */
+	log = fopen(LOG_FNAME, "w");
+	if (log == NULL)
+		printf("%s: Unable to create log file %s (%s)\n", NAME, LOG_FNAME,
+		    str_error(errno));
+	
 	async_set_interrupt_received(interrupt_received);
 	klog_update();
Index: uspace/app/netecho/Makefile
===================================================================
--- uspace/app/netecho/Makefile	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/netecho/Makefile	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -29,6 +29,6 @@
 
 USPACE_PREFIX = ../..
-LIBS = $(LIBSOCKET_PREFIX)/libsocket.a
-EXTRA_CFLAGS = -I$(LIBSOCKET_PREFIX)/include
+LIBS = 
+EXTRA_CFLAGS = 
 BINARY = netecho
 
Index: uspace/app/netecho/netecho.c
===================================================================
--- uspace/app/netecho/netecho.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/netecho/netecho.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -41,11 +41,11 @@
 #include <task.h>
 #include <arg_parse.h>
-
-#include <in.h>
-#include <in6.h>
-#include <inet.h>
-#include <socket.h>
-#include <net_err.h>
-#include <socket_parse.h>
+#include <err.h>
+
+#include <net/in.h>
+#include <net/in6.h>
+#include <net/inet.h>
+#include <net/socket.h>
+#include <net/socket_parse.h>
 
 #include "print_error.h"
Index: uspace/app/netecho/print_error.c
===================================================================
--- uspace/app/netecho/print_error.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/netecho/print_error.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -36,7 +36,7 @@
 
 #include <stdio.h>
+#include <errno.h>
 
-#include <icmp_codes.h>
-#include <socket_errno.h>
+#include <net/icmp_codes.h>
 
 #include "print_error.h"
Index: uspace/app/nettest1/Makefile
===================================================================
--- uspace/app/nettest1/Makefile	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/nettest1/Makefile	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -29,6 +29,6 @@
 
 USPACE_PREFIX = ../..
-LIBS = $(LIBSOCKET_PREFIX)/libsocket.a
-EXTRA_CFLAGS = -I$(LIBSOCKET_PREFIX)/include
+LIBS = 
+EXTRA_CFLAGS = 
 BINARY = nettest1
 
Index: uspace/app/nettest1/nettest.c
===================================================================
--- uspace/app/nettest1/nettest.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/nettest1/nettest.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -36,7 +36,7 @@
 
 #include <stdio.h>
-
-#include <socket.h>
-#include <net_err.h>
+#include <err.h>
+
+#include <net/socket.h>
 
 #include "nettest.h"
Index: uspace/app/nettest1/nettest.h
===================================================================
--- uspace/app/nettest1/nettest.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/nettest1/nettest.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -38,5 +38,5 @@
 #define __NET_TEST__
 
-#include <socket.h>
+#include <net/socket.h>
 
 /** Prints a mark.
Index: uspace/app/nettest1/nettest1.c
===================================================================
--- uspace/app/nettest1/nettest1.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/nettest1/nettest1.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -41,11 +41,11 @@
 #include <time.h>
 #include <arg_parse.h>
-
-#include <in.h>
-#include <in6.h>
-#include <inet.h>
-#include <socket.h>
-#include <net_err.h>
-#include <socket_parse.h>
+#include <err.h>
+
+#include <net/in.h>
+#include <net/in6.h>
+#include <net/inet.h>
+#include <net/socket.h>
+#include <net/socket_parse.h>
 
 #include "nettest.h"
Index: uspace/app/nettest2/Makefile
===================================================================
--- uspace/app/nettest2/Makefile	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/nettest2/Makefile	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -29,6 +29,6 @@
 
 USPACE_PREFIX = ../..
-LIBS = $(LIBSOCKET_PREFIX)/libsocket.a
-EXTRA_CFLAGS = -I$(LIBSOCKET_PREFIX)/include
+LIBS = 
+EXTRA_CFLAGS = 
 BINARY = nettest2
 
Index: uspace/app/nettest2/nettest2.c
===================================================================
--- uspace/app/nettest2/nettest2.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/nettest2/nettest2.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -41,11 +41,11 @@
 #include <time.h>
 #include <arg_parse.h>
-
-#include <in.h>
-#include <in6.h>
-#include <inet.h>
-#include <socket.h>
-#include <net_err.h>
-#include <socket_parse.h>
+#include <err.h>
+
+#include <net/in.h>
+#include <net/in6.h>
+#include <net/inet.h>
+#include <net/socket.h>
+#include <net/socket_parse.h>
 
 #include "nettest.h"
Index: uspace/app/ping/Makefile
===================================================================
--- uspace/app/ping/Makefile	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/ping/Makefile	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -29,6 +29,6 @@
 
 USPACE_PREFIX = ../..
-LIBS = $(LIBSOCKET_PREFIX)/libsocket.a
-EXTRA_CFLAGS = -I$(LIBSOCKET_PREFIX)/include
+LIBS = 
+EXTRA_CFLAGS = 
 BINARY = ping
 
Index: uspace/app/ping/ping.c
===================================================================
--- uspace/app/ping/ping.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/ping/ping.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -42,13 +42,13 @@
 #include <ipc/services.h>
 #include <str_error.h>
+#include <errno.h>
 #include <arg_parse.h>
 
-#include <icmp_api.h>
-#include <in.h>
-#include <in6.h>
-#include <inet.h>
-#include <ip_codes.h>
-#include <socket_errno.h>
-#include <socket_parse.h>
+#include <net/icmp_api.h>
+#include <net/in.h>
+#include <net/in6.h>
+#include <net/inet.h>
+#include <net/socket_parse.h>
+#include <net/ip_codes.h>
 
 #include "print_error.h"
Index: uspace/app/sbi/Makefile
===================================================================
--- uspace/app/sbi/Makefile	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/Makefile	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -35,6 +35,8 @@
 SOURCES = \
 	src/builtin/bi_boxed.c \
+	src/builtin/bi_char.c \
 	src/builtin/bi_error.c \
 	src/builtin/bi_fun.c \
+	src/builtin/bi_int.c \
 	src/builtin/bi_textfile.c \
 	src/builtin/bi_string.c \
Index: uspace/app/sbi/src/ancr.c
===================================================================
--- uspace/app/sbi/src/ancr.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/ancr.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -51,4 +51,5 @@
 #include <assert.h>
 #include "builtin.h"
+#include "cspan.h"
 #include "list.h"
 #include "mytypes.h"
@@ -61,4 +62,6 @@
 static void ancr_csi_dfs(stree_program_t *prog, stree_csi_t *csi);
 static void ancr_csi_process(stree_program_t *prog, stree_csi_t *node);
+static stree_csi_t *ancr_csi_get_pred(stree_program_t *prog, stree_csi_t *csi,
+    stree_texpr_t *pred_ref);
 static void ancr_csi_print_cycle(stree_program_t *prog, stree_csi_t *node);
 
@@ -128,44 +131,34 @@
  *
  * @param prog		Program being processed.
- * @param node		CSI node to process.
- */
-static void ancr_csi_process(stree_program_t *prog, stree_csi_t *node)
-{
-	stree_symbol_t *base_sym;
+ * @param csi		CSI node to process.
+ */
+static void ancr_csi_process(stree_program_t *prog, stree_csi_t *csi)
+{
 	stree_csi_t *base_csi, *outer_csi;
 	stree_csi_t *gf_class;
 
-	if (node->ancr_state == ws_visited) {
+	list_node_t *pred_n;
+	stree_texpr_t *pred;
+	stree_csi_t *pred_csi;
+
+	if (csi->ancr_state == ws_visited) {
 		/* Node already processed */
 		return;
 	}
 
-	if (node->ancr_state == ws_active) {
+	if (csi->ancr_state == ws_active) {
 		/* Error, closed reference loop. */
 		printf("Error: Circular class, struct or interface chain: ");
-		ancr_csi_print_cycle(prog, node);
+		ancr_csi_print_cycle(prog, csi);
 		printf(".\n");
 		exit(1);
 	}
 
-	node->ancr_state = ws_active;
-
-	outer_csi = csi_to_symbol(node)->outer_csi;
+	csi->ancr_state = ws_active;
+
+	outer_csi = csi_to_symbol(csi)->outer_csi;
 	gf_class = builtin_get_gf_class(prog->builtin);
 
-	/* Process outer CSI */
-	if (outer_csi != NULL)
-		ancr_csi_process(prog, outer_csi);
-
-	if (node->base_csi_ref != NULL) {
-		/* Resolve base CSI. */
-		base_sym = symbol_xlookup_in_csi(prog, outer_csi,
-			node->base_csi_ref);
-		base_csi = symbol_to_csi(base_sym);
-		assert(base_csi != NULL);
-
-		/* Process base CSI. */
-		ancr_csi_process(prog, base_csi);
-	} else if (node != gf_class) {
+	if (csi != gf_class){
 		/* Implicit inheritance from grandfather class. */
 		base_csi = gf_class;
@@ -175,7 +168,100 @@
 	}
 
+	/* Process outer CSI */
+	if (outer_csi != NULL)
+		ancr_csi_process(prog, outer_csi);
+
+	/*
+	 * Process inheritance list.
+	 */
+	pred_n = list_first(&csi->inherit);
+
+	/* For a class node, the first entry can be a class. */
+	if (csi->cc == csi_class && pred_n != NULL) {
+		pred = list_node_data(pred_n, stree_texpr_t *);
+		pred_csi = ancr_csi_get_pred(prog, csi, pred);
+		assert(pred_csi != NULL);
+
+		if (pred_csi->cc == csi_class) {
+			/* Process base class */
+			base_csi = pred_csi;
+			ancr_csi_process(prog, pred_csi);
+
+			pred_n = list_next(&csi->inherit, pred_n);
+		}
+	}
+
+	/* Following entires can only be interfaces. */
+	while (pred_n != NULL) {
+		pred = list_node_data(pred_n, stree_texpr_t *);
+		pred_csi = ancr_csi_get_pred(prog, csi, pred);
+		assert(pred_csi != NULL);
+
+		/* Process implemented or accumulated interface. */
+		ancr_csi_process(prog, pred_csi);
+
+		switch (pred_csi->cc) {
+		case csi_class:
+			switch (csi->cc) {
+			case csi_class:
+				cspan_print(csi->name->cspan);
+				printf(" Error: Only the first predecessor "
+				    "can be a class. ('");
+				symbol_print_fqn(csi_to_symbol(csi));
+				printf("' deriving from '");
+				symbol_print_fqn(csi_to_symbol(pred_csi));
+				printf("').\n");
+				exit(1);
+				break;
+			case csi_struct:
+				assert(b_false); /* XXX */
+			case csi_interface:
+				cspan_print(csi->name->cspan);
+				printf(" Error: Interface predecessor must be "
+				    "an interface ('");
+				symbol_print_fqn(csi_to_symbol(csi));
+				printf("' deriving from '");
+				symbol_print_fqn(csi_to_symbol(pred_csi));
+				printf("').\n");
+				exit(1);
+				break;
+			}
+		case csi_struct:
+			assert(b_false); /* XXX */
+		case csi_interface:
+			break;
+		}
+
+		pred_n = list_next(&csi->inherit, pred_n);
+	}
+
 	/* Store base CSI and update node state. */
-	node->ancr_state = ws_visited;
-	node->base_csi = base_csi;
+	csi->ancr_state = ws_visited;
+	csi->base_csi = base_csi;
+}
+
+/** Resolve CSI predecessor reference.
+ *
+ * Returns the CSI predecessor referenced by @a pred_ref.
+ * If the referenced CSI does not exist, an error is generated.
+ *
+ * @param prog		Program being processed.
+ * @param csi		CSI node to process.
+ * @param pred_ref	Type expression referencing the predecessor.
+ * @return		Predecessor CSI.
+ */
+static stree_csi_t *ancr_csi_get_pred(stree_program_t *prog, stree_csi_t *csi,
+    stree_texpr_t *pred_ref)
+{
+	stree_csi_t *outer_csi;
+	stree_symbol_t *pred_sym;
+	stree_csi_t *pred_csi;
+
+	outer_csi = csi_to_symbol(csi)->outer_csi;
+	pred_sym = symbol_xlookup_in_csi(prog, outer_csi, pred_ref);
+	pred_csi = symbol_to_csi(pred_sym);
+	assert(pred_csi != NULL); /* XXX */
+
+	return pred_csi;
 }
 
@@ -191,6 +277,8 @@
 {
 	stree_csi_t *n;
-	stree_symbol_t *base_sym, *node_sym;
-	stree_csi_t *base_csi, *outer_csi;
+	stree_symbol_t *pred_sym, *node_sym;
+	stree_csi_t *pred_csi, *outer_csi;
+	stree_texpr_t *pred;
+	list_node_t *pred_n;
 
 	n = node;
@@ -204,15 +292,22 @@
 		if (outer_csi != NULL && outer_csi->ancr_state == ws_active) {
 			node = outer_csi;
-		} else if (node->base_csi_ref != NULL) {
-			/* Resolve base CSI. */
-			base_sym = symbol_xlookup_in_csi(prog, outer_csi,
-				node->base_csi_ref);
-			base_csi = symbol_to_csi(base_sym);
-			assert(base_csi != NULL);
-
-			assert(base_csi->ancr_state == ws_active);
-			node = base_csi;
 		} else {
-			assert(b_false);
+			node = NULL;
+
+			pred_n = list_first(&node->inherit);
+			while (pred_n != NULL) {
+				pred = list_node_data(pred_n, stree_texpr_t *);
+				pred_sym = symbol_xlookup_in_csi(prog,
+				    outer_csi, pred);
+				pred_csi = symbol_to_csi(pred_sym);
+				assert(pred_csi != NULL);
+
+				if (pred_csi->ancr_state == ws_active) {
+					node = pred_csi;
+					break;
+				}
+			}
+
+			assert(node != NULL);
 		}
 	} while (n != node);
Index: uspace/app/sbi/src/bigint.c
===================================================================
--- uspace/app/sbi/src/bigint.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/bigint.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -360,28 +360,31 @@
 }
 
-/** Print bigint to standard output. */
-void bigint_print(bigint_t *bigint)
-{
+/** Convert bigint to string.
+ *
+ * @param bigint	Bigint to convert.
+ * @param dptr		Place to store pointer to new string.
+ */
+void bigint_get_as_string(bigint_t *bigint, char **dptr)
+{
+	static const char digits[] = { '0', '1', '2', '3', '4', '5', '6',
+	    '7', '8', '9' };
+
 	bigint_t val, tmp;
 	bigint_word_t rem;
-	size_t ndigits;
-	int *digits;
-	size_t idx;
-
-#ifdef DEBUG_BIGINT_TRACE
-	printf("Print bigint.\n");
+	size_t nchars;
+	char *str;
+	size_t idx;
+
+#ifdef DEBUG_BIGINT_TRACE
+	printf("Convert bigint to string.\n");
 #endif
 	assert(BIGINT_BASE >= 10);
 
-	if (bigint_is_zero(bigint)) {
-		putchar('0');
-		return;
-	}
-
-	if (bigint->negative)
-		putchar('-');
-
-	/* Compute number of digits. */
-	ndigits = 0;
+	/* Compute number of characters. */
+	nchars = 0;
+
+	if (bigint_is_zero(bigint) || bigint->negative)
+		nchars += 1; /* '0' or '-' */
+
 	bigint_clone(bigint, &val);
 	while (bigint_is_zero(&val) != b_true) {
@@ -390,17 +393,23 @@
 		bigint_shallow_copy(&tmp, &val);
 
-		ndigits += 1;
+		nchars += 1;
 	}
 	bigint_destroy(&val);
 
-	/* Store digits to array. */
-
-	digits = malloc(ndigits * sizeof(int));
-	if (digits == NULL) {
+	/* Store characters to array. */
+
+	str = malloc(nchars * sizeof(char) + 1);
+	if (str == NULL) {
 		printf("Memory allocation failed.\n");
 		exit(1);
 	}
 
-	idx = 0;
+	if (bigint_is_zero(bigint)) {
+		str[0] = '0';
+	} else if (bigint->negative) {
+		str[0] = '-';
+	}
+
+	idx = 1;
 	bigint_clone(bigint, &val);
 	while (bigint_is_zero(&val) != b_true) {
@@ -409,12 +418,27 @@
 		bigint_shallow_copy(&tmp, &val);
 
-		digits[idx++] = (int) rem;
-	}
+		str[nchars - idx] = digits[(int) rem];
+		++idx;
+	}
+
 	bigint_destroy(&val);
-
-	for (idx = 0; idx < ndigits; ++idx)
-		printf("%u", digits[ndigits - 1 - idx]);
-
-	free(digits);
+	str[nchars] = '\0';
+	*dptr = str;
+}
+
+/** Print bigint to standard output.
+ *
+ * @param bigint	Bigint to print.
+ */
+void bigint_print(bigint_t *bigint)
+{
+	char *str;
+
+#ifdef DEBUG_BIGINT_TRACE
+	printf("Print bigint.\n");
+#endif
+	bigint_get_as_string(bigint, &str);
+	printf("%s", str);
+	free(str);
 }
 
Index: uspace/app/sbi/src/bigint.h
===================================================================
--- uspace/app/sbi/src/bigint.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/bigint.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -48,4 +48,6 @@
 void bigint_sub(bigint_t *a, bigint_t *b, bigint_t *dest);
 void bigint_mul(bigint_t *a, bigint_t *b, bigint_t *dest);
+
+void bigint_get_as_string(bigint_t *bigint, char **dptr);
 void bigint_print(bigint_t *bigint);
 
